"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CircomMainComponentVisitor = void 0;
const CircomExpressionVisitor_1 = require("./CircomExpressionVisitor");
const generated_1 = require("../generated");
class CircomMainComponentVisitor extends generated_1.CircomVisitor {
    mainComponentInfo;
    constructor() {
        super();
        this.mainComponentInfo = {
            templateName: null,
            publicInputs: [],
            parameters: [],
        };
    }
    visitComponentMainDeclaration = (ctx) => {
        this.mainComponentInfo.templateName = ctx.ID().getText();
        if (ctx.publicInputsList() &&
            ctx.publicInputsList().args() &&
            ctx.publicInputsList().args().ID_list()) {
            ctx
                .publicInputsList()
                .args()
                .ID_list()
                .forEach((input) => {
                this.mainComponentInfo.publicInputs.push(input.getText());
            });
        }
        if (ctx.expressionList() && ctx.expressionList().expression_list()) {
            const expressionVisitor = new CircomExpressionVisitor_1.CircomExpressionVisitor(false);
            ctx
                .expressionList()
                .expression_list()
                .forEach((expression) => {
                this.mainComponentInfo.parameters.push(expressionVisitor.visitExpression(expression));
            });
        }
    };
}
exports.CircomMainComponentVisitor = CircomMainComponentVisitor;
