"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CircomExpressionVisitor = exports.CircomMainComponentVisitor = exports.CircomTemplateVisitor = exports.CircomIncludeVisitor = exports.CircomPragmaVisitor = void 0;
exports.findTemplates = findTemplates;
exports.findIncludes = findIncludes;
exports.findMainComponent = findMainComponent;
exports.findPragma = findPragma;
const CircomPragmaVisitor_1 = require("./CircomPragmaVisitor");
Object.defineProperty(exports, "CircomPragmaVisitor", { enumerable: true, get: function () { return CircomPragmaVisitor_1.CircomPragmaVisitor; } });
const CircomIncludeVisitor_1 = require("./CircomIncludeVisitor");
Object.defineProperty(exports, "CircomIncludeVisitor", { enumerable: true, get: function () { return CircomIncludeVisitor_1.CircomIncludeVisitor; } });
const CircomTemplateVisitor_1 = require("./CircomTemplateVisitor");
Object.defineProperty(exports, "CircomTemplateVisitor", { enumerable: true, get: function () { return CircomTemplateVisitor_1.CircomTemplateVisitor; } });
const CircomMainComponentVisitor_1 = require("./CircomMainComponentVisitor");
Object.defineProperty(exports, "CircomMainComponentVisitor", { enumerable: true, get: function () { return CircomMainComponentVisitor_1.CircomMainComponentVisitor; } });
const __1 = require("..");
function findTemplates(source) {
    const parser = (0, __1.getCircomParser)(source);
    const templateVisitor = new CircomTemplateVisitor_1.CircomTemplateVisitor();
    const context = parser.circuit();
    if (parser.hasAnyErrors()) {
        throw new __1.ParserError(parser.getAllErrors());
    }
    templateVisitor.visit(context);
    return templateVisitor.templates;
}
function findIncludes(source) {
    const parser = (0, __1.getCircomParser)(source);
    const includeDeclarationVisitor = new CircomIncludeVisitor_1.CircomIncludeVisitor();
    const context = parser.circuit();
    if (parser.hasAnyErrors()) {
        throw new __1.ParserError(parser.getAllErrors());
    }
    includeDeclarationVisitor.visit(context);
    return includeDeclarationVisitor.packageNames;
}
function findMainComponent(source) {
    const parser = (0, __1.getCircomParser)(source);
    const mainComponentVisitor = new CircomMainComponentVisitor_1.CircomMainComponentVisitor();
    const context = parser.circuit();
    if (parser.hasAnyErrors()) {
        throw new __1.ParserError(parser.getAllErrors());
    }
    mainComponentVisitor.visit(context);
    return mainComponentVisitor.mainComponentInfo;
}
function findPragma(source) {
    const parser = (0, __1.getCircomParser)(source);
    const pragmaVisitor = new CircomPragmaVisitor_1.CircomPragmaVisitor();
    const context = parser.circuit();
    if (parser.hasAnyErrors()) {
        throw new __1.ParserError(parser.getAllErrors());
    }
    pragmaVisitor.visit(context);
    return {
        isCustom: pragmaVisitor.isCustom,
        compilerVersion: pragmaVisitor.compilerVersion,
    };
}
__exportStar(require("./utils"), exports);
var CircomExpressionVisitor_1 = require("./CircomExpressionVisitor");
Object.defineProperty(exports, "CircomExpressionVisitor", { enumerable: true, get: function () { return CircomExpressionVisitor_1.CircomExpressionVisitor; } });
