"use strict";
// Generated from parser/Circom.g4 by ANTLR 4.13.1
Object.defineProperty(exports, "__esModule", { value: true });
const antlr4_1 = require("antlr4");
/**
 * This interface defines a complete generic visitor for a parse tree produced
 * by `CircomParser`.
 *
 * @param <Result> The return type of the visit operation. Use `void` for
 * operations with no return type.
 */
class CircomVisitor extends antlr4_1.ParseTreeVisitor {
    /**
     * Visit a parse tree produced by `CircomParser.circuit`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitCircuit;
    /**
     * Visit a parse tree produced by `CircomParser.pragmaDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitPragmaDeclaration;
    /**
     * Visit a parse tree produced by `CircomParser.includeDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitIncludeDeclaration;
    /**
     * Visit a parse tree produced by `CircomParser.blockDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitBlockDeclaration;
    /**
     * Visit a parse tree produced by `CircomParser.functionDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFunctionDeclaration;
    /**
     * Visit a parse tree produced by `CircomParser.functionBlock`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFunctionBlock;
    /**
     * Visit a parse tree produced by the `FuncBlock`
     * labeled alternative in `CircomParser.functionStmt`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFuncBlock;
    /**
     * Visit a parse tree produced by the `FuncSelfOp`
     * labeled alternative in `CircomParser.functionStmt`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFuncSelfOp;
    /**
     * Visit a parse tree produced by the `FuncVarDeclaration`
     * labeled alternative in `CircomParser.functionStmt`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFuncVarDeclaration;
    /**
     * Visit a parse tree produced by the `FuncAssignmentExpression`
     * labeled alternative in `CircomParser.functionStmt`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFuncAssignmentExpression;
    /**
     * Visit a parse tree produced by the `FuncVariadicAssignment`
     * labeled alternative in `CircomParser.functionStmt`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitFuncVariadicAssignment;
    /**
     * Visit a parse tree produced by the `IfFuncStmt`
     * labeled alternative in `CircomParser.functionStmt`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitIfFuncStmt;
    /**
     * Visit a parse tree produced by the `WhileFuncStmt`
     * labeled alternative in `CircomParser.functionStmt`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitWhileFuncStmt;
    /**
     * Visit a parse tree produced by the `ForFuncStmt`
     * labeled alternative in `CircomParser.functionStmt`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitForFuncStmt;
    /**
     * Visit a parse tree produced by the `ReturnFuncStmt`
     * labeled alternative in `CircomParser.functionStmt`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitReturnFuncStmt;
    /**
     * Visit a parse tree produced by the `AssertFuncStmt`
     * labeled alternative in `CircomParser.functionStmt`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitAssertFuncStmt;
    /**
     * Visit a parse tree produced by the `LogFuncStmt`
     * labeled alternative in `CircomParser.functionStmt`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitLogFuncStmt;
    /**
     * Visit a parse tree produced by `CircomParser.templateDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitTemplateDeclaration;
    /**
     * Visit a parse tree produced by `CircomParser.templateBlock`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitTemplateBlock;
    /**
     * Visit a parse tree produced by `CircomParser.componentMainDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitComponentMainDeclaration;
    /**
     * Visit a parse tree produced by `CircomParser.publicInputsList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitPublicInputsList;
    /**
     * Visit a parse tree produced by `CircomParser.templateStmt`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitTemplateStmt;
    /**
     * Visit a parse tree produced by `CircomParser.forControl`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitForControl;
    /**
     * Visit a parse tree produced by `CircomParser.forInit`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitForInit;
    /**
     * Visit a parse tree produced by `CircomParser.forUpdate`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitForUpdate;
    /**
     * Visit a parse tree produced by `CircomParser.parExpression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitParExpression;
    /**
     * Visit a parse tree produced by the `TernaryExpression`
     * labeled alternative in `CircomParser.expression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitTernaryExpression;
    /**
     * Visit a parse tree produced by the `DotExpression`
     * labeled alternative in `CircomParser.expression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitDotExpression;
    /**
     * Visit a parse tree produced by the `PrimaryExpression`
     * labeled alternative in `CircomParser.expression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitPrimaryExpression;
    /**
     * Visit a parse tree produced by the `BinaryExpression`
     * labeled alternative in `CircomParser.expression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitBinaryExpression;
    /**
     * Visit a parse tree produced by the `BlockInstantiationExpression`
     * labeled alternative in `CircomParser.expression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitBlockInstantiationExpression;
    /**
     * Visit a parse tree produced by the `UnaryExpression`
     * labeled alternative in `CircomParser.expression`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitUnaryExpression;
    /**
     * Visit a parse tree produced by `CircomParser.primary`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitPrimary;
    /**
     * Visit a parse tree produced by `CircomParser.logStmt`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitLogStmt;
    /**
     * Visit a parse tree produced by `CircomParser.componentDefinition`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitComponentDefinition;
    /**
     * Visit a parse tree produced by `CircomParser.componentDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitComponentDeclaration;
    /**
     * Visit a parse tree produced by `CircomParser.signalDefinition`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitSignalDefinition;
    /**
     * Visit a parse tree produced by `CircomParser.tagList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitTagList;
    /**
     * Visit a parse tree produced by `CircomParser.signalDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitSignalDeclaration;
    /**
     * Visit a parse tree produced by `CircomParser.varDefinition`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitVarDefinition;
    /**
     * Visit a parse tree produced by `CircomParser.varDeclaration`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitVarDeclaration;
    /**
     * Visit a parse tree produced by `CircomParser.rhsValue`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitRhsValue;
    /**
     * Visit a parse tree produced by `CircomParser.componentCall`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitComponentCall;
    /**
     * Visit a parse tree produced by `CircomParser.blockInstantiation`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitBlockInstantiation;
    /**
     * Visit a parse tree produced by `CircomParser.expressionList`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitExpressionList;
    /**
     * Visit a parse tree produced by `CircomParser.identifier`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitIdentifier;
    /**
     * Visit a parse tree produced by `CircomParser.arrayDimension`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitArrayDimension;
    /**
     * Visit a parse tree produced by `CircomParser.args`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitArgs;
    /**
     * Visit a parse tree produced by `CircomParser.argsWithUnderscore`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitArgsWithUnderscore;
    /**
     * Visit a parse tree produced by `CircomParser.numSequence`.
     * @param ctx the parse tree
     * @return the visitor result
     */
    visitNumSequence;
}
exports.default = CircomVisitor;
